%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                      %%
%%  ClientServer tool: Server.oz example                                %%
%%                                                                      %%
%%  (c) 2000 Universit catholique de Louvain.  All Rights Reserved.    %%
%%  The development of ClientServer is supported by the PIRATES project %%
%%  at the Universit catholique de Louvain.  This file is subject to   %%
%%  the general Mozart license.                                         %%
%%                                                                      %%
%%  Author: Peter Van Roy                                               %%
%%                                                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import Compiler
export query:Q
define
   fun {Q E} 
      try
         {Compiler.evalExpression E env _} 
      catch X then
         % The exception's 'debug' field contains a huge amount of
         % information, which causes a large transmission delay.
         % Removing the field avoids this delay:
         raise {AdjoinAt X debug 'REMOVED'} end
      end
   end
end
